求两数之和 | leetcode

苟哥 2020-01-28 AM 2357℃ 0条

题目描述

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解法一

使用暴力解法,嵌套循环求和判断,时间复杂度为O(n^2):

class Solution {
    public int[] twoSum(int[] nums, int target) {
        int[] res = new int[2];
        for(int i = 0; i < nums.length - 1; i++){
            for(int j = i + 1; j < nums.length; j++){
                if(nums[i] + nums[j] == target){
                    res[0] = i;
                    res[1] = j;
                    break;
                }
            }
        }
        return res;
    }
}

执行结果:

解法二

使用哈希表,降低计算维度,时间复杂度为O(n):

class Solution {
    public int[] twoSum(int[] nums, int target) {
        int[] res = new int[2];

        HashMap<Integer,Integer> hash = new HashMap<Integer,Integer>();
        for(int i = 0; i < nums.length; i++){
            if(hash.containsKey(nums[i])){
                res[0] = hash.get(nums[i]);
                res[1] = i;
                return res;
            }
            // 将可能的数存入hashmap,差值作为键 ,下标作为值
            hash.put(target-nums[i], i);
        }
        return res;
    }
}

执行结果:

非特殊说明,本博所有文章均为博主原创。

评论啦~